<?php
	
	define("API_URL", "https://sandbox.esignlive.com/api/packages");
	define("MULTIPART_BOUNDARY", "----WebKitFormBoundary7MA4YWxkTrZu0gW"); 

	$api_headers = array(
		"Authorization: Basic your_api_key",
		"Accept: application/json; esl-api-version=10.13",
		"Content-Type: multipart/form-data; boundary=\"" . MULTIPART_BOUNDARY . "\"",
	);



	$json = [
	   "roles" => [
			 [
				"id" => "Signer1", 
				"signers" => [
				   [
					  "email" => "esignguide1@mailinator.com", 
					  "firstName" => "John", 
					  "lastName" => "Smith",
					  "id" => "Signer1",
				   ] 
				] 
			 ] 
		  ], 
	   "documents" => [
						 [
							"approvals" => [
							   [
								  "role" => "Signer1", 
								  "fields" => [
									 [
										"page" => 0, 
										"top" => 100, 
										"subtype" => "FULLNAME", 
										"height" => 50, 
										"left" => 100, 
										"width" => 200, 
										"type" => "SIGNATURE" 
									 ] 
								  ] 
							   ] 
							], 
							"name" => "Test Document" 
						 ] 
					  ], 
	   "name" => "PHP Example Package", 
	   "language" => "en", 
	   "status" => "SENT" 
	]; 


	$postdata = "--" . MULTIPART_BOUNDARY . "\r\n";
	$postdata .= "Content-Disposition: form-data; name=\"file\"; filename=\"sample_contract2.pdf\"\r\n\r\n";
	$postdata .= file_get_contents("documents/sample_contract2.pdf");
	$postdata .= "\r\n\r\n";
	$postdata .= "--" . MULTIPART_BOUNDARY . "\r\n";
	$postdata .= "Content-Disposition: form-data; name=\"payload\"\r\n\r\n";
	$postdata .= json_encode($json);
	$postdata .= "\r\n\r\n";
	$postdata .= "--" . MULTIPART_BOUNDARY . "--\r\n";

	$curl = curl_init(API_URL);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($curl, CURLOPT_POST          , true);
	curl_setopt($curl, CURLOPT_POSTFIELDS    , $postdata);
	curl_setopt($curl, CURLOPT_HTTPHEADER    , $api_headers);
	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
	curl_exec($curl);
	$response = curl_multi_getcontent($curl);
	curl_close($curl);
	
	
	$packageId = json_decode($response, true);
	$url = "https://sandbox.esignlive.com/api/authenticationTokens/signer/singleUse";  
	$build = array(
		'packageId' => $packageId['id'],
		'signerId' => 'Signer1'
	);	
	$content = json_encode($build);

	$api_headers = array(
		"Authorization: Basic your_api_key",
		"Accept: application/json; esl-api-version=10.13",
		"Content-Type: application/json",
	);
	
	$curl = curl_init($url);
	curl_setopt($curl, CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $api_headers);
	curl_setopt($curl, CURLOPT_POST, true);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $content);

	$json_response = curl_exec($curl);

	curl_close($curl);

	$response = json_decode($json_response, true);
	
	print_r("https://sandbox.esignlive.com/access?sessionToken=".$response['value']);

	
	
?>